/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*
	ObjESSty-1
*/

#include <exception>

#include <oess_1/defs/impl/h/catch_all.hpp>

#include <oess_1/db/cln/h/db.hpp>

namespace oess_1 {

namespace db {

namespace cln {

//
// db_t
//

db_t::db_t(
	oess_1::db::site::abstract_connector_t * connector ) :
	m_connector_ptr( connector )
{
}

db_t::~db_t()
{
	__OESS_CATCH_ALL(
		m_connector_ptr.destroy();
	)
}

oess_1::db::site::abstract_connector_t &
db_t::query_connector()
{
	return *m_connector_ptr;
}

const oess_1::db::site::abstract_connector_t &
db_t::query_connector() const
{
	return *m_connector_ptr;
}

//
// transaction_t
//

transaction_t::transaction_t( db_t & db,
	std::ostream * errs )
:
	m_db( db )
,	m_is_finished( false )
,	m_errs( errs )
{
	m_db.transaction_begin();
}
transaction_t::~transaction_t()
{
	try
	{
		if( !m_is_finished )
			m_db.transaction_rollback();
	}
	catch( std::exception & x )
	{
		if( m_errs )
			(*m_errs) << x.what() << std::endl;
	}
	catch( ... )
	{
		if( m_errs )
			(*m_errs) << __FILE__ << ":" << __LINE__
				<< ": unknown exception caught" << std::endl;
	}
}

void
transaction_t::commit()
{
	// Даже, если возникнет исключение, откат в деструкторе
	// осуществлять не нужно.
	m_is_finished = true;
	m_db.transaction_commit();
}

} /* namespace cln */

} /* namespace db */

} /* namespace oess_1 */
